/******************************************************************************
	(C) 2017. IntBuSoft. http://intbusoft.com
	DataMatrixReader.h - version 1.1
*******************************************************************************/
#pragma once

#include "opencv2/core/core_c.h"
#include "opencv2/imgproc/imgproc_c.h"
#ifdef _DEBUG
#include "opencv2/highgui/highgui_c.h"
#endif

#define DM_THRESHOLD	0x01
#define DM_ATHRESHOLD	0x02
#define DM_HIGHQUALITY	0x04
#define DM_MINDECODEERROR	0x08

#define MAX_DMCODE	10

struct DM_RESULT
{
	CvPoint Points[4];
	char result[1600];
};
/*
	Image        - GrayScale image;
	ResultDM     - Array for barcodes result (all_result size);
	all_result   - max count of barcodes;
	param        -
	      if ( mode_binary & DM_THRESHOLD ) == DM_THRESHOLD ) then param = threshold;
		      if param == 0 then param = Otsu Threshold from image
		  if ( mode_binary & DM_ATHRESHOLD ) == DM_ATHRESHOLD ) then param = neighbourhood size
	mode_binary  -  (DM_THRESHOLD or DM_ATHRESHOLD) and (DM_HIGHQUALITY or 0) and (DM_MINDECODEERROR or 0)

	Return:
	-1           - exception;
	0            - correct work (count of codes result = all_result).
*/
int 
#ifdef WIN32
__stdcall 
#endif
DataMatrixCodeReader(IplImage* Image,DM_RESULT* ResultDM,int* all_result,int param,int mode_binary);